package com.ldonglg.flutter_adid_plugin

import android.content.Context
import android.os.AsyncTask
import android.text.TextUtils
import androidx.annotation.NonNull;
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

/** FlutterAdidPlugin */
public class FlutterAdidPlugin : FlutterPlugin, MethodCallHandler {
    

    private val mContext: Context = GlobalContext.context

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        val channel = MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "flutter_adid_plugin")
        channel.setMethodCallHandler(FlutterAdidPlugin())
    }

    // This static function is optional and equivalent to onAttachedToEngine. It supports the old
    // pre-Flutter-1.12 Android projects. You are encouraged to continue supporting
    // plugin registration via this function while apps migrate to use the new Android APIs
    // post-flutter-1.12 via https://flutter.dev/go/android-project-migration.
    //
    // It is encouraged to share logic between onAttachedToEngine and registerWith to keep
    // them functionally equivalent. Only one of onAttachedToEngine or registerWith will be called
    // depending on the user's project. onAttachedToEngine or registerWith must both be defined
    // in the same class.
    companion object {
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val channel = MethodChannel(registrar.messenger(), "flutter_adid_plugin")
            channel.setMethodCallHandler(FlutterAdidPlugin())
        }
    }

    override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
        if (call.method == "get_adid_or_idfa") {
            GetTask(result).execute(mContext)
        } else {
            result.notImplemented()
        }
    }

    class GetTask(@NonNull result: Result) : AsyncTask<Context, Void, String>() {
        private val mResult: Result = result

        override fun doInBackground(vararg context: Context?): String {
            try {
                return DeviceUtils.getGoogleAdId(context[0])
            } catch (e: Exception) {
                return ""
            }
        }

        override fun onPostExecute(adId: String?) {
            super.onPostExecute(adId)
            if (adId.isNullOrEmpty()) {
                mResult.success("")
            } else {
                mResult.success(adId)
            }
        }

    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
    }
}
