import Flutter
import UIKit
import AdSupport

public class SwiftFlutterAdidPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_adid_plugin", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterAdidPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "get_adid_or_idfa":
        // get IDFA of IOS
        let idfa = ASIdentifierManager.shared().advertisingIdentifier.uuidString
        result(idfa)
        break;
    default:
        result(FlutterMethodNotImplemented)
    }
  }
}
